#!/usr/bin/php
<?php

require_once('/usr/local/opmon/etc/config.php');

function main() {

    try {
        $opt = parse_options();
    } catch(Exception $e) {
        print sprintf("%s\n", $e->getMessage());
        return 3;
    }
    $countername = $opt->counter;
    $proccap = $opt->caption;

    $wmic = WmicFactory::createFromCredentialId($opt->host, $opt->credential);

    try {
        $ret = $wmic->do_query(
            "select {$countername} from Win32_Process where Caption='{$proccap}'"
        );
    } catch(Exception $e) {
        print sprintf("%s\n", $e->getMessage());
        return 3;
    }


    if (count($ret) == 0) {
        print "Unable to locate process {$proccap}\n";
        return 2;
    }
    $ret = array_shift($ret);


    $total = 0;
    foreach($ret->objects as $obj) {

        $val = $obj->$countername;
        if (ctype_digit($val) === FALSE) {
            print sprintf("%s\n", $val);
            return 0;
        }

        $total += $val;
    }

    $outstr = sprintf("%s %s %s |%s=%s;%d;%d;;\n",
        $proccap,
        $countername,
        $val,
        $countername,
        $val,
        $opt->warning,
        $opt->critical
    );

    print $outstr;

    if (is_null($opt->warning) || is_null($opt->critical))
        return 0;

    if ($opt->warning < $opt->critical) {
        if ($val > $opt->critical)
            return 2;
        else if ($val > $opt->warning)
            return 1;
        return 0;
    }

    if ($val < $opt->critical)
        return 2;
    else if ($val < $opt->warning)
        return 1;
    return 0;
}

function parse_options() {

    $opt = new StdClass();
    $opt->warning = NULL;
    $opt->critical = NULL;

    $options = getopt("h:C:e:d:w:c:D:");
    if (!isset($options['h']))
        throw new Exception("Invalid host address(-h)");
    if (!isset($options['C']))
        throw new Exception("Invalid username(-C)");
    if (!isset($options['e']))
        throw new Exception("Invalid process caption(-e)");
    if (!isset($options['d']))
        throw new Exception("Invalid data counter(-d)");
    if (isset($options['w']))
        $opt->warning = sprintf("%d", $options['w']);
    if (isset($options['c']))
        $opt->critical = sprintf("%d", $options['c']);

    $opt->host = $options['h'];
    $opt->credential = $options['C'];
    $opt->caption = $options['e'];
    $opt->counter = $options['d'];
    $opt->domain = isset($options['D']) ? $options['D'] : "";

    return $opt;
}

exit(main());
