#!/usr/bin/php
<?php

require_once('/usr/local/opmon/etc/config.php');

function main() {

    try {
        $opt = parse_options();
    } catch(Exception $e) {
        print sprintf("%s\n", $e->getMessage());
        return 3;
    }
    $sname = $opt->service_name;

    $wmic = WmicFactory::createFromCredentialId($opt->host, $opt->credential);

    try {
        $ret = $wmic->do_query(
            "select Started from Win32_Service where Name = '{$sname}'"
        );
    } catch(Exception $e) {
        print sprintf("%s\n", $e->getMessage());
        return 3;
    }

    if (count($ret) == 0) {
        print "Unable to locate service {$sname}\n";
        return 2;
    }
    $ret = array_shift($ret);

    $running = TRUE;
    foreach($ret->objects as $obj) {
        $counter++;
        if ($obj->Started != 'True')
            $running = FALSE;
    }

    print sprintf("%s state: %s\n",
        $opt->service_name,
        ($running)? "running" : "stopped"
    );

    if ($running)
        return 0;
    return 2;
}

function parse_options() {

    $opt = new StdClass();

    $options = getopt("h:C:n:D:");
    if (!isset($options['h']))
        throw new Exception("Invalid host address(-h)");
    if (!isset($options['C']))
        throw new Exception("Invalid username(-C)");
    if (!isset($options['n']))
        throw new Exception("Invalid service name(-n)");

    $opt->host = $options['h'];
    $opt->credential = $options['C'];
    $opt->service_name = $options['n'];
    $opt->domain = isset($options['D']) ? $options['D'] : "";

    return $opt;
}

exit(main());
